# Blank Vars
tags_buildname="";vm_storagecontainer_name="";resourcegroup_name="";vm_storageaccounts_name="";vm_storageaccount_key=""

api="2015-06-15"

while getopts ":a:b:c:d:e:" o; do
case "${o}" in
		a) tags_buildname=${OPTARG} ;;
		b) vm_storagecontainer_name=${OPTARG} ;;
		c) resourcegroup_name=${OPTARG} ;;
		d) vm_storageaccounts_name=${OPTARG} ;;
		e) vm_storageaccount_key=${OPTARG} ;;
	esac
done
shift $((OPTIND-1))

if [ -z "$tags_buildname" ]; then tags_buildname="testbuild01"; echo "No Variable Passed, setting to default: tags_buildname:" $tags_buildname; else echo "Custom Variable Passed:		 	tags_buildname:" $tags_buildname; fi
if [ -z "$vm_storagecontainer_name" ]; then vm_storagecontainer_name="testbuild01"; echo "No Variable Passed, setting to default: vm_storagecontainer_name:" $vm_storagecontainer_name; else echo "Custom Variable Passed:		 	vm_storagecontainer_name:" $vm_storagecontainer_name; fi
if [ -z "$resourcegroup_name" ]; then resourcegroup_name="RG1"; echo "No Variable Passed, setting to default: resourcegroup_name:" $resourcegroup_name; else echo "Custom Variable Passed:		 	resourcegroup_name:" $resourcegroup_name; fi
if [ -z "$vm_storageaccounts_name" ]; then vm_storageaccounts_name='wltest'; echo "No Variable Passed, setting to default: vm_storageaccounts_name:" $vm_storageaccounts_name; else echo "Custom Variable Passed:		 	vm_storageaccounts_name:" $vm_storageaccounts_name; fi
if [ -z "$vm_storageaccount_key" ]; then vm_storageaccount_key='r4xasdf34fafaferfafafaerfELZuJ2BjlGRaasdfasdfasdfasdfasdfLGYa4f3276Q=='; echo "No Variable Passed, setting to default: vm_storageaccount_key:" $vm_storageaccount_key; else echo "Custom Variable Passed:		 	vm_storageaccount_key:" $vm_storageaccount_key; fi

#list all resources
resourcelist=$(azure resource list -g $resourcegroup_name --json)

#dump to var
out1=$(echo $resourcelist | jq -cM ".[] | select(.tags.BuildName | contains(\"$tags_buildname\"))?")
#echo $out1 | jq 

#Join Everything
paris=$(echo $out1 | jq -cM '[.name, .type] | join("|,|")')

#Start To Remove Everything

#remove all virtual machines
echo "About to remove all virutal machines"
for pair in $paris
do 
name=$(echo $pair | cut -f 1 -d,| tr -d '"',"|")
net=$(echo $pair | cut -f 2 -d,| tr -d '"',"|")
#echo -e "my name: $name\tmy net:$net test"
if [[ $net == "Microsoft.Compute/virtualMachines" ]]
then
azure resource delete -g $resourcegroup_name -n $name -r $net -o $api -q
fi
done

#loop to make sure the servers are gone before continuing
n=1
number=1
while (( $n == 1 ))
do
n=0
looplist=$(azure resource list -g $resourcegroup_name --json)
loop1=$(echo $looplist | jq -cM ".[] | select(.tags.BuildName | contains(\"$tags_buildname\"))?")
loop2=$(echo $loop1 | jq -cM '[.name, .type] | join("|,|")')
for thing in $loop2
do 
net=$(echo $thing | cut -f 2 -d,| tr -d '"',"|")
if [[ $net == "Microsoft.Compute/virtualMachines" ]]
then
echo $net
n=1
echo "We are waiting for the virutal machines to be removed"
echo "Please Hold: Loop number $number"
else
number=$[$number+1]
fi
done
sleep 5
done

#remove all network interfaces
echo "About to remove Network Interfaces"
for pair in $paris
do 
name=$(echo $pair | cut -f 1 -d,| tr -d '"',"|")
net=$(echo $pair | cut -f 2 -d,| tr -d '"',"|")
if [[ $net == "Microsoft.Network/networkInterfaces" ]]
then
azure resource delete -g $resourcegroup_name -n $name -r $net -o $api -q
fi
done

#remove all network security resourcegroups
echo "About to remove all network security resourcegroups"
for pair in $paris
do 
name=$(echo $pair | cut -f 1 -d,| tr -d '"',"|")
net=$(echo $pair | cut -f 2 -d,| tr -d '"',"|")
if [[ $net == "Microsoft.Network/networkSecurityresourcegroups" ]]
then
azure resource delete -g $resourcegroup_name -n $name -r $net -o $api -q
fi
done

#remove all availability sets
echo "About to remove all availability sets"
for pair in $paris
do 
name=$(echo $pair | cut -f 1 -d,| tr -d '"',"|")
net=$(echo $pair | cut -f 2 -d,| tr -d '"',"|")
if [[ $net == "Microsoft.Compute/availabilitySets" ]]
then
azure resource delete -g $resourcegroup_name -n $name -r $net -o $api -q
fi
done

#remove all load balancers
echo "About to remove all load balancers"
for pair in $paris
do 
name=$(echo $pair | cut -f 1 -d,| tr -d '"',"|")
net=$(echo $pair | cut -f 2 -d,| tr -d '"',"|")
if [[ $net == "Microsoft.Network/loadBalancers" ]]
then
azure resource delete -g $resourcegroup_name -n $name -r $net -o $api -q
fi
done

#remove all public ip addresses
echo "About to remove all public ip addresses"
for pair in $paris
do 
name=$(echo $pair | cut -f 1 -d,| tr -d '"',"|")
net=$(echo $pair | cut -f 2 -d,| tr -d '"',"|")
if [[ $net == "Microsoft.Network/publicIPAddresses" ]]
then
azure resource delete -g $resourcegroup_name -n $name -r $net -o $api -q
fi
done

#Delete the Container
echo "About to Delete the Container"
containerlist=$(azure storage container list -a $vm_storageaccounts_name -k $vm_storageaccount_key)
if [[ $containerlist == *"$vm_storagecontainer_name"* ]]
then
str=$(echo $containerlist | grep -oh "[[:alpha:]]*$vm_storagecontainer_name[[:alpha:]]*")
for value1 in $str
do 
azure storage container delete --container $value1 -a $vm_storageaccounts_name -k $vm_storageaccount_key -q
done
fi
echo "Finished"

